<?xml version="1.0" encoding="UTF-8"?>
<!-- XBRL document created with DocuBuilder 4.9 by Appatura -->
<!--XBRL-1318-->
<link:linkbase xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.xbrl.org/2003/linkbase http://www.xbrl.org/2003/xbrl-linkbase-2003-12-31.xsd" xmlns:link="http://www.xbrl.org/2003/linkbase" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xbrli="http://www.xbrl.org/2003/instance">
	<link:roleRef roleURI="http://jhfii-20190101/role/OperatingExpensesDataAAAA" xlink:type="simple" xlink:href="jhfii-20190101.xsd#OperatingExpensesDataAAAA"/>
	<link:calculationLink xlink:type="extended" xlink:role="http://jhfii-20190101/role/OperatingExpensesDataAAAA">
		<link:loc xlink:type="locator" xlink:href="http://xbrl.sec.gov/rr/2012/rr-2012-01-31.xsd#rr_NetExpensesOverAssets" xlink:label="NetExpensesOverAssets"/>
		<link:loc xlink:type="locator" xlink:href="http://xbrl.sec.gov/rr/2012/rr-2012-01-31.xsd#rr_ExpensesOverAssets" xlink:label="ExpensesOverAssets"/>
		<link:calculationArc xlink:type="arc" xlink:arcrole="http://www.xbrl.org/2003/arcrole/summation-item" xlink:from="NetExpensesOverAssets" xlink:to="ExpensesOverAssets" use="optional" priority="1" order="1.0" weight="1"/>
		<link:loc xlink:type="locator" xlink:href="http://xbrl.sec.gov/rr/2012/rr-2012-01-31.xsd#rr_ManagementFeesOverAssets" xlink:label="ManagementFeesOverAssets"/>
		<link:calculationArc xlink:type="arc" xlink:arcrole="http://www.xbrl.org/2003/arcrole/summation-item" xlink:from="ExpensesOverAssets" xlink:to="ManagementFeesOverAssets" use="optional" priority="1" order="1.0" weight="1"/>
		<link:loc xlink:type="locator" xlink:href="http://xbrl.sec.gov/rr/2012/rr-2012-01-31.xsd#rr_DistributionAndService12b1FeesOverAssets" xlink:label="DistributionAndService12b1FeesOverAssets"/>
		<link:calculationArc xlink:type="arc" xlink:arcrole="http://www.xbrl.org/2003/arcrole/summation-item" xlink:from="ExpensesOverAssets" xlink:to="DistributionAndService12b1FeesOverAssets" use="optional" priority="1" order="2.0" weight="1"/>
		<link:loc xlink:type="locator" xlink:href="http://xbrl.sec.gov/rr/2012/rr-2012-01-31.xsd#rr_DistributionOrSimilarNon12b1FeesOverAssets" xlink:label="DistributionOrSimilarNon12b1FeesOverAssets"/>
		<link:calculationArc xlink:type="arc" xlink:arcrole="http://www.xbrl.org/2003/arcrole/summation-item" xlink:from="ExpensesOverAssets" xlink:to="DistributionOrSimilarNon12b1FeesOverAssets" use="optional" priority="1" order="3.0" weight="1"/>
		<link:loc xlink:type="locator" xlink:href="http://xbrl.sec.gov/rr/2012/rr-2012-01-31.xsd#rr_OtherExpensesOverAssets" xlink:label="OtherExpensesOverAssets"/>
		<link:calculationArc xlink:type="arc" xlink:arcrole="http://www.xbrl.org/2003/arcrole/summation-item" xlink:from="ExpensesOverAssets" xlink:to="OtherExpensesOverAssets" use="optional" priority="1" order="4.0" weight="1"/>
		<link:loc xlink:type="locator" xlink:href="http://xbrl.sec.gov/rr/2012/rr-2012-01-31.xsd#rr_Component1OtherExpensesOverAssets" xlink:label="Component1OtherExpensesOverAssets"/>
		<link:calculationArc xlink:type="arc" xlink:arcrole="http://www.xbrl.org/2003/arcrole/summation-item" xlink:from="OtherExpensesOverAssets" xlink:to="Component1OtherExpensesOverAssets" use="optional" priority="1" order="1.0" weight="1"/>
		<link:loc xlink:type="locator" xlink:href="http://xbrl.sec.gov/rr/2012/rr-2012-01-31.xsd#rr_Component2OtherExpensesOverAssets" xlink:label="Component2OtherExpensesOverAssets"/>
		<link:calculationArc xlink:type="arc" xlink:arcrole="http://www.xbrl.org/2003/arcrole/summation-item" xlink:from="OtherExpensesOverAssets" xlink:to="Component2OtherExpensesOverAssets" use="optional" priority="1" order="2.0" weight="1"/>
		<link:loc xlink:type="locator" xlink:href="http://xbrl.sec.gov/rr/2012/rr-2012-01-31.xsd#rr_Component3OtherExpensesOverAssets" xlink:label="Component3OtherExpensesOverAssets"/>
		<link:calculationArc xlink:type="arc" xlink:arcrole="http://www.xbrl.org/2003/arcrole/summation-item" xlink:from="OtherExpensesOverAssets" xlink:to="Component3OtherExpensesOverAssets" use="optional" priority="1" order="3.0" weight="1"/>
		<link:loc xlink:type="locator" xlink:href="http://xbrl.sec.gov/rr/2012/rr-2012-01-31.xsd#rr_AcquiredFundFeesAndExpensesOverAssets" xlink:label="AcquiredFundFeesAndExpensesOverAssets"/>
		<link:calculationArc xlink:type="arc" xlink:arcrole="http://www.xbrl.org/2003/arcrole/summation-item" xlink:from="ExpensesOverAssets" xlink:to="AcquiredFundFeesAndExpensesOverAssets" use="optional" priority="1" order="5.0" weight="1"/>
		<link:loc xlink:type="locator" xlink:href="http://xbrl.sec.gov/rr/2012/rr-2012-01-31.xsd#rr_FeeWaiverOrReimbursementOverAssets" xlink:label="FeeWaiverOrReimbursementOverAssets"/>
		<link:calculationArc xlink:type="arc" xlink:arcrole="http://www.xbrl.org/2003/arcrole/summation-item" xlink:from="NetExpensesOverAssets" xlink:to="FeeWaiverOrReimbursementOverAssets" use="optional" priority="1" order="2.0" weight="1"/>
	</link:calculationLink>
</link:linkbase>
